# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Resource types

* [`dsc_webapplicationhandler`](#dsc_webapplicationhandler): The DSC WebApplicationHandler resource type. Automatically generated from version 3.2.0
* [`dsc_xiisfeaturedelegation`](#dsc_xiisfeaturedelegation): The DSC xIisFeatureDelegation resource type. Automatically generated from version 3.2.0
* [`dsc_xiishandler`](#dsc_xiishandler): The DSC xIisHandler resource type. Automatically generated from version 3.2.0
* [`dsc_xiislogging`](#dsc_xiislogging): The DSC xIisLogging resource type. Automatically generated from version 3.2.0
* [`dsc_xiismimetypemapping`](#dsc_xiismimetypemapping): The DSC xIisMimeTypeMapping resource type. Automatically generated from version 3.2.0
* [`dsc_xiismodule`](#dsc_xiismodule): The DSC xIisModule resource type. Automatically generated from version 3.2.0
* [`dsc_xsslsettings`](#dsc_xsslsettings): The DSC xSslSettings resource type. Automatically generated from version 3.2.0
* [`dsc_xwebapplication`](#dsc_xwebapplication): The DSC xWebApplication resource type. Automatically generated from version 3.2.0
* [`dsc_xwebapppool`](#dsc_xwebapppool): The DSC xWebAppPool resource type. Automatically generated from version 3.2.0
* [`dsc_xwebapppooldefaults`](#dsc_xwebapppooldefaults): The DSC xWebAppPoolDefaults resource type. Automatically generated from version 3.2.0
* [`dsc_xwebconfigkeyvalue`](#dsc_xwebconfigkeyvalue): The DSC xWebConfigKeyValue resource type. Automatically generated from version 3.2.0
* [`dsc_xwebconfigproperty`](#dsc_xwebconfigproperty): The DSC xWebConfigProperty resource type. Automatically generated from version 3.2.0
* [`dsc_xwebconfigpropertycollection`](#dsc_xwebconfigpropertycollection): The DSC xWebConfigPropertyCollection resource type. Automatically generated from version 3.2.0
* [`dsc_xwebsite`](#dsc_xwebsite): The DSC xWebSite resource type. Automatically generated from version 3.2.0
* [`dsc_xwebsitedefaults`](#dsc_xwebsitedefaults): The DSC xWebSiteDefaults resource type. Automatically generated from version 3.2.0
* [`dsc_xwebvirtualdirectory`](#dsc_xwebvirtualdirectory): The DSC xWebVirtualDirectory resource type. Automatically generated from version 3.2.0

## Resource types

### <a name="dsc_webapplicationhandler"></a>`dsc_webapplicationhandler`

The DSC WebApplicationHandler resource type.
Automatically generated from version 3.2.0

#### Properties

The following properties are available in the `dsc_webapplicationhandler` type.

##### `dsc_allowpathinfo`

Data type: `Optional[Boolean]`

Specifies whether the handler processes full path information in a URI, such as contoso/marketing/imageGallery.aspx. If the value is true, the handler processes the full path, contoso/marketing/imageGallery. If the value is false, the handler processes only the last section of the path, /imageGallery.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Indicates if the application handler exists. Set this property to `Absent` to ensure that the application handler does not exist. Default value is 'Present'.

##### `dsc_location`

Data type: `Optional[String]`

Specifies The location of the configuration setting. Location tags are frequently used for configuration settings that must be set more precisely than per application or per virtual directory.

##### `dsc_modules`

Data type: `Optional[String]`

Specifies the modules used for the handler.

##### `dsc_path`

Data type: `Array[String]`

Specifies an IIS configuration path.

##### `dsc_physicalhandlerpath`

Data type: `Optional[String]`

Specifies the physical path to the handler. This parameter applies to native modules only.

##### `dsc_precondition`

Data type: `Optional[String]`

Specifies preconditions for the new handler.

##### `dsc_requireaccess`

Data type: `Optional[Enum['None', 'Read', 'Write', 'Script', 'Execute']]`

Specifies the user rights that are required for the new handler.

##### `dsc_resourcetype`

Data type: `Optional[String]`

Specifies the resource type this handler runs.

##### `dsc_responsebufferlimit`

Data type: `Optional[Integer[0, 4294967295]]`

Specifies the maximum size, in bytes, of the response buffer for a request handler runs.

##### `dsc_scriptprocessor`

Data type: `Optional[String]`

Specifies the script processor that runs for the module.

##### `dsc_type`

Data type: `Optional[String]`

Specifies the managed type of the new module. This parameter applies to managed modules only.

##### `dsc_verb`

Data type: `Optional[String]`

Specifies the HTTP verbs that are handled by the new handler.

#### Parameters

The following parameters are available in the `dsc_webapplicationhandler` type.

* [`dsc_name`](#dsc_name)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_name"></a>`dsc_name`

namevar

Data type: `String`

Specifies the name of the new request handler.

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xiisfeaturedelegation"></a>`dsc_xiisfeaturedelegation`

The DSC xIisFeatureDelegation resource type.
Automatically generated from version 3.2.0

#### Properties

The following properties are available in the `dsc_xiisfeaturedelegation` type.

##### `dsc_overridemode`

Data type: `Enum['Allow', 'Deny']`

Determines whether to lock or unlock the specified section.

#### Parameters

The following parameters are available in the `dsc_xiisfeaturedelegation` type.

* [`dsc_filter`](#dsc_filter)
* [`dsc_path`](#dsc_path)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_filter"></a>`dsc_filter`

namevar

Data type: `String`

Specifies the IIS configuration section to lock or unlock.

##### <a name="dsc_path"></a>`dsc_path`

namevar

Data type: `String`

Specifies the configuration path. This can be either an IIS configuration path in the format computer
machine/webroot/apphost, or the IIS module path in this format IIS:\sites\Default Web Site.

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xiishandler"></a>`dsc_xiishandler`

The DSC xIisHandler resource type.
Automatically generated from version 3.2.0

#### Properties

The following properties are available in the `dsc_xiishandler` type.

##### `dsc_ensure`

Data type: `Enum['Present', 'Absent']`

Ensures that the handler is Present or Absent. Defaults to Present.

#### Parameters

The following parameters are available in the `dsc_xiishandler` type.

* [`dsc_name`](#dsc_name)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_name"></a>`dsc_name`

namevar

Data type: `String`

The name of the handler, for example 'PageHandlerFactory-Integrated-4.0'

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xiislogging"></a>`dsc_xiislogging`

The DSC xIisLogging resource type.
Automatically generated from version 3.2.0

#### Properties

The following properties are available in the `dsc_xiislogging` type.

##### `dsc_logcustomfields`

Data type: `Optional[Array[Struct[{
              sourcetype => Enum['RequestHeader', 'ResponseHeader', 'ServerVariable'],
              sourcename => String,
              ensure => Optional[Enum['Present', 'Absent']],
              logfieldname => String
            }]]]`

Custom logging field information in the form of an array of embedded instances of MSFT_xLogCustomField CIM class

##### `dsc_logflags`

Data type: `Optional[Array[Enum['Date', 'Time', 'ClientIP', 'UserName', 'SiteName', 'ComputerName', 'ServerIP', 'Method', 'UriStem', 'UriQuery', 'HttpStatus', 'Win32Status', 'BytesSent', 'BytesRecv', 'TimeTaken', 'ServerPort', 'UserAgent', 'Cookie', 'Referer', 'ProtocolVersion', 'Host', 'HttpSubStatus']]]`

The W3C logging fields

##### `dsc_logformat`

Data type: `Optional[Enum['IIS', 'W3C', 'NCSA']]`

Format of the Logfiles. Only W3C supports LogFlags

##### `dsc_loglocaltimerollover`

Data type: `Optional[Boolean]`

Use the localtime for file naming and rollover

##### `dsc_logperiod`

Data type: `Optional[Enum['Hourly', 'Daily', 'Weekly', 'Monthly', 'MaxSize']]`

How often the log file should rollover

##### `dsc_logtargetw3c`

Data type: `Optional[Enum['File', 'ETW', 'File,ETW']]`

Specifies whether IIS will use Event Tracing or file logging

##### `dsc_logtruncatesize`

Data type: `Optional[String]`

How large the file should be before it is truncated

#### Parameters

The following parameters are available in the `dsc_xiislogging` type.

* [`dsc_logpath`](#dsc_logpath)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_logpath"></a>`dsc_logpath`

namevar

Data type: `String`

The directory to be used for logfiles

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xiismimetypemapping"></a>`dsc_xiismimetypemapping`

The DSC xIisMimeTypeMapping resource type.
Automatically generated from version 3.2.0

#### Properties

The following properties are available in the `dsc_xiismimetypemapping` type.

##### `dsc_ensure`

Data type: `Enum['Present', 'Absent']`

Ensures that the MIME type mapping is Present or Absent.

#### Parameters

The following parameters are available in the `dsc_xiismimetypemapping` type.

* [`dsc_configurationpath`](#dsc_configurationpath)
* [`dsc_extension`](#dsc_extension)
* [`dsc_mimetype`](#dsc_mimetype)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_configurationpath"></a>`dsc_configurationpath`

namevar

Data type: `String`

This can be either an IIS configuration path in the format computername/webroot/apphost, or the IIS module path in this
format IIS:\sites\Default Web Site.

##### <a name="dsc_extension"></a>`dsc_extension`

namevar

Data type: `String`

The file extension to map such as .html or .xml.

##### <a name="dsc_mimetype"></a>`dsc_mimetype`

namevar

Data type: `String`

The MIME type to map that extension to such as text/html.

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xiismodule"></a>`dsc_xiismodule`

The DSC xIisModule resource type.
Automatically generated from version 3.2.0

#### Properties

The following properties are available in the `dsc_xiismodule` type.

##### `dsc_endpointsetup`

Data type: `Optional[Boolean]`

The End Point is setup.  Such as a Fast Cgi endpoint.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Should the module be present or absent.

##### `dsc_moduletype`

Data type: `Optional[Enum['FastCgiModule']]`

The type of the module.

##### `dsc_name`

Data type: `String`

The logical name of the module to add to IIS.

##### `dsc_requestpath`

Data type: `String`

The allowed request Path example: *.php

##### `dsc_sitename`

Data type: `Optional[String]`

The IIS Site to register the module.

##### `dsc_verb`

Data type: `Array[String]`

The supported verbs for the module.

#### Parameters

The following parameters are available in the `dsc_xiismodule` type.

* [`dsc_path`](#dsc_path)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_path"></a>`dsc_path`

namevar

Data type: `String`

The path to the module, usually a dll, to be added to IIS.

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xsslsettings"></a>`dsc_xsslsettings`

The DSC xSslSettings resource type.
Automatically generated from version 3.2.0

#### Properties

The following properties are available in the `dsc_xsslsettings` type.

##### `dsc_bindings`

Data type: `Array[Enum['', 'Ssl', 'SslNegotiateCert', 'SslRequireCert', 'Ssl128']]`

The Bindings in which to modify for the website

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Whether the bindings should be present or absent

#### Parameters

The following parameters are available in the `dsc_xsslsettings` type.

* [`dsc_name`](#dsc_name)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_name"></a>`dsc_name`

namevar

Data type: `String`

Name of website in which to modify the SSL Settings

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xwebapplication"></a>`dsc_xwebapplication`

The DSC xWebApplication resource type.
Automatically generated from version 3.2.0

#### Properties

The following properties are available in the `dsc_xwebapplication` type.

##### `dsc_applicationtype`

Data type: `Optional[String]`

Adds a AutostartProvider ApplicationType

##### `dsc_authenticationinfo`

Data type: `Optional[Struct[{
              basic => Optional[Boolean],
              anonymous => Optional[Boolean],
              digest => Optional[Boolean],
              windows => Optional[Boolean]
            }]]`

Hashtable containing authentication information (Anonymous, Basic, Digest, Windows)

##### `dsc_enabledprotocols`

Data type: `Optional[Array[Enum['http', 'https', 'net.tcp', 'net.msmq', 'net.pipe']]]`

Adds EnabledProtocols on an Application

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Whether web application should be present or absent

##### `dsc_physicalpath`

Data type: `String`

Physical path for the web application directory

##### `dsc_preloadenabled`

Data type: `Optional[Boolean]`

Allows a Application to automatically start without a request

##### `dsc_serviceautostartenabled`

Data type: `Optional[Boolean]`

Enables Autostart on an Application.

##### `dsc_serviceautostartprovider`

Data type: `Optional[String]`

Adds a AutostartProvider

##### `dsc_sslflags`

Data type: `Optional[Array[Enum['', 'Ssl', 'SslNegotiateCert', 'SslRequireCert', 'Ssl128']]]`

SSLFlags for the application

##### `dsc_webapppool`

Data type: `String`

Web application pool for the web application

#### Parameters

The following parameters are available in the `dsc_xwebapplication` type.

* [`dsc_name`](#dsc_name)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`dsc_website`](#dsc_website)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_name"></a>`dsc_name`

namevar

Data type: `String`

Name of web application

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="dsc_website"></a>`dsc_website`

namevar

Data type: `String`

Name of website with which web application is associated

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xwebapppool"></a>`dsc_xwebapppool`

The DSC xWebAppPool resource type.
Automatically generated from version 3.2.0

#### Properties

The following properties are available in the `dsc_xwebapppool` type.

##### `dsc_autoshutdownexe`

Data type: `Optional[String]`

Indicates an executable to run when the application pool is shut down by rapid-fail protection.

##### `dsc_autoshutdownparams`

Data type: `Optional[String]`

Indicates parameters for the executable that is specified in the autoShutdownExe property.

##### `dsc_autostart`

Data type: `Optional[Boolean]`

When set to true, indicates to the World Wide Web Publishing Service (W3SVC) that the application pool should be automatically started when it is created or when IIS is started.

##### `dsc_clrconfigfile`

Data type: `Optional[String]`

Indicates the .NET configuration file for the application pool.

##### `dsc_cpuaction`

Data type: `Optional[Enum['NoAction', 'KillW3wp', 'Throttle', 'ThrottleUnderLoad']]`

Configures the action that IIS takes when a worker process exceeds its configured CPU limit. The values that are allowed for this property are: NoAction, KillW3wp, Throttle, and ThrottleUnderLoad.

##### `dsc_cpulimit`

Data type: `Optional[Integer[0, 4294967295]]`

Configures the maximum percentage of CPU time (in 1/1000ths of one percent) that the worker processes in the application pool are allowed to consume over a period of time as indicated by the cpuResetInterval property. The value must be a valid integer between 0 and 100000.

##### `dsc_cpuresetinterval`

Data type: `Optional[String]`

Indicates the reset period (in minutes) for CPU monitoring and throttling limits on the application pool. The value must be a string representation of a TimeSpan value. The valid range (in minutes) is 0 to 1440. Setting the value of this property to 0 disables CPU monitoring.

##### `dsc_cpusmpaffinitized`

Data type: `Optional[Boolean]`

Indicates whether a particular worker process assigned to the application pool should also be assigned to a given CPU.

##### `dsc_cpusmpprocessoraffinitymask`

Data type: `Optional[Integer[0, 4294967295]]`

Indicates the hexadecimal processor mask for multi-processor computers, which indicates to which CPU the worker processes in the application pool should be bound. Before this property takes effect, the cpuSmpAffinitized property must be set to true for the application pool. The value must be a valid integer between 0 and 4294967295.

##### `dsc_cpusmpprocessoraffinitymask2`

Data type: `Optional[Integer[0, 4294967295]]`

Indicates the high-order DWORD hexadecimal processor mask for 64-bit multi-processor computers, which indicates to which CPU the worker processes in the application pool should be bound. Before this property takes effect, the cpuSmpAffinitized property must be set to true for the application pool. The value must be a valid integer between 0 and 4294967295.

##### `dsc_disallowoverlappingrotation`

Data type: `Optional[Boolean]`

Indicates whether the W3SVC service should start another worker process to replace the existing worker process while that process is shutting down. If true, the application pool recycle will happen such that the existing worker process exits before another worker process is created.

##### `dsc_disallowrotationonconfigchange`

Data type: `Optional[Boolean]`

Indicates whether the W3SVC service should rotate worker processes in the application pool when the configuration has changed. If true, the application pool will not recycle when its configuration is changed.

##### `dsc_enable32bitapponwin64`

Data type: `Optional[Boolean]`

When set to true, enables a 32-bit application to run on a computer that runs a 64-bit version of Windows.

##### `dsc_enableconfigurationoverride`

Data type: `Optional[Boolean]`

When set to true, indicates that delegated settings in Web.config files will processed for applications within this application pool. When set to false, all settings in Web.config files will be ignored for this application pool.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Indicates if the application pool exists. Set this property to Absent to ensure that the application pool does not exist. Setting it to Present (the default value) ensures that the application pool exists.

##### `dsc_identitytype`

Data type: `Optional[Enum['ApplicationPoolIdentity', 'LocalService', 'LocalSystem', 'NetworkService', 'SpecificUser']]`

Indicates the account identity under which the application pool runs. The values that are allowed for this property are: ApplicationPoolIdentity, LocalService, LocalSystem, NetworkService, and SpecificUser.

##### `dsc_idletimeout`

Data type: `Optional[String]`

Indicates the amount of time (in minutes) a worker process will remain idle before it shuts down. The value must be a string representation of a TimeSpan value and must be less than the restartTimeLimit property value. The valid range (in minutes) is 0 to 43200.

##### `dsc_idletimeoutaction`

Data type: `Optional[Enum['Terminate', 'Suspend']]`

Indicates the action to perform when the idle timeout duration has been reached. The values that are allowed for this property are: Terminate, Suspend.

##### `dsc_loadbalancercapabilities`

Data type: `Optional[Enum['HttpLevel', 'TcpLevel']]`

Indicates the response behavior of a service when it is unavailable. The values that are allowed for this property are: HttpLevel, TcpLevel. If set to HttpLevel and the application pool is stopped, HTTP.sys will return HTTP 503 error. If set to TcpLevel, HTTP.sys will reset the connection.

##### `dsc_loaduserprofile`

Data type: `Optional[Boolean]`

Indicates whether IIS loads the user profile for the application pool identity.

##### `dsc_logeventonprocessmodel`

Data type: `Optional[String]`

Indicates that IIS should generate an event log entry for each occurrence of the specified process model events.

##### `dsc_logeventonrecycle`

Data type: `Optional[String]`

Indicates that IIS should generate an event log entry for each occurrence of the specified recycling events.

##### `dsc_logontype`

Data type: `Optional[Enum['LogonBatch', 'LogonService']]`

Indicates the logon type for the process identity. The values that are allowed for this property are: LogonBatch, LogonService.

##### `dsc_managedpipelinemode`

Data type: `Optional[Enum['Integrated', 'Classic']]`

Indicates the request-processing mode that is used to process requests for managed content. The values that are allowed for this property are: Integrated, Classic.

##### `dsc_managedruntimeloader`

Data type: `Optional[String]`

Indicates the managed loader to use for pre-loading the application pool.

##### `dsc_managedruntimeversion`

Data type: `Optional[Enum['v4.0', 'v2.0', '']]`

Indicates the CLR version to be used by the application pool. The values that are allowed for this property are: v4.0, v2.0, and ''.

##### `dsc_manualgroupmembership`

Data type: `Optional[Boolean]`

Indicates whether the IIS_IUSRS group Security Identifier (SID) is added to the worker process token.

##### `dsc_maxprocesses`

Data type: `Optional[Integer[0, 4294967295]]`

Indicates the maximum number of worker processes that would be used for the application pool. The value must be a valid integer between 0 and 2147483647.

##### `dsc_orphanactionexe`

Data type: `Optional[String]`

Indicates an executable to run when a worker process is orphaned.

##### `dsc_orphanactionparams`

Data type: `Optional[String]`

Indicates parameters for the executable that is specified in the orphanActionExe property.

##### `dsc_orphanworkerprocess`

Data type: `Optional[Boolean]`

Indicates whether to assign a worker process to an orphan state instead of terminating it when the application pool fails. If true, an unresponsive worker process will be orphaned instead of terminated.

##### `dsc_passanonymoustoken`

Data type: `Optional[Boolean]`

When set to true, the Windows Process Activation Service (WAS) creates and passes a token for the built-in IUSR anonymous user account to the Anonymous authentication module. The Anonymous authentication module uses the token to impersonate the built-in account. When this property is set to false, the token will not be passed.

##### `dsc_pingingenabled`

Data type: `Optional[Boolean]`

Indicates whether pinging (health monitoring) is enabled for the worker process(es) serving this application pool.

##### `dsc_pinginterval`

Data type: `Optional[String]`

Indicates the period of time (in seconds) between health monitoring pings sent to the worker process(es) serving this application pool. The value must be a string representation of a TimeSpan value. The valid range (in seconds) is 1 to 4294967.

##### `dsc_pingresponsetime`

Data type: `Optional[String]`

Indicates the maximum time (in seconds) that a worker process is given to respond to a health monitoring ping. The value must be a string representation of a TimeSpan value. The valid range (in seconds) is 1 to 4294967.

##### `dsc_queuelength`

Data type: `Optional[Integer[0, 4294967295]]`

Indicates the maximum number of requests that HTTP.sys will queue for the application pool. The value must be a valid integer between 10 and 65535.

##### `dsc_rapidfailprotection`

Data type: `Optional[Boolean]`

Indicates whether rapid-fail protection is enabled. If true, the application pool is shut down if there are a specified number of worker process crashes within a specified time period.

##### `dsc_rapidfailprotectioninterval`

Data type: `Optional[String]`

Indicates the time interval (in minutes) during which the specified number of worker process crashes must occur before the application pool is shut down by rapid-fail protection. The value must be a string representation of a TimeSpan value. The valid range (in minutes) is 1 to 144000.

##### `dsc_rapidfailprotectionmaxcrashes`

Data type: `Optional[Integer[0, 4294967295]]`

Indicates the maximum number of worker process crashes permitted before the application pool is shut down by rapid-fail protection. The value must be a valid integer between 0 and 2147483647.

##### `dsc_restartmemorylimit`

Data type: `Optional[Integer[0, 4294967295]]`

Indicates the maximum amount of virtual memory (in KB) a worker process can consume before causing the application pool to recycle. The value must be a valid integer between 0 and 4294967295. A value of 0 means there is no limit.

##### `dsc_restartprivatememorylimit`

Data type: `Optional[Integer[0, 4294967295]]`

Indicates the maximum amount of private memory (in KB) a worker process can consume before causing the application pool to recycle. The value must be a valid integer between 0 and 4294967295. A value of 0 means there is no limit.

##### `dsc_restartrequestslimit`

Data type: `Optional[Integer[0, 4294967295]]`

Indicates the maximum number of requests the application pool can process before it is recycled. The value must be a valid integer between 0 and 4294967295. A value of 0 means the application pool can process an unlimited number of requests.

##### `dsc_restartschedule`

Data type: `Optional[Array[String]]`

Indicates a set of specific local times, in 24 hour format, when the application pool is recycled. The value must be an array of string representations of TimeSpan values. TimeSpan values must be between 00:00:00 and 23:59:59 seconds inclusive, with a granularity of 60 seconds. Setting the value of this property to '' disables the schedule.

##### `dsc_restarttimelimit`

Data type: `Optional[String]`

Indicates the period of time (in minutes) after which the application pool will recycle. The value must be a string representation of a TimeSpan value. The valid range (in minutes) is 0 to 432000. A value of 0 means the application pool does not recycle on a regular interval.

##### `dsc_setprofileenvironment`

Data type: `Optional[Boolean]`

Indicates the environment to be set based on the user profile for the new process.

##### `dsc_shutdowntimelimit`

Data type: `Optional[String]`

Indicates the period of time (in seconds) a worker process is given to finish processing requests and shut down. The value must be a string representation of a TimeSpan value. The valid range (in seconds) is 1 to 4294967.

##### `dsc_startmode`

Data type: `Optional[Enum['OnDemand', 'AlwaysRunning']]`

Indicates the startup type for the application pool. The values that are allowed for this property are: OnDemand, AlwaysRunning.

##### `dsc_startuptimelimit`

Data type: `Optional[String]`

Indicates the period of time (in seconds) a worker process is given to start up and initialize. The value must be a string representation of a TimeSpan value. The valid range (in seconds) is 1 to 4294967.

##### `dsc_state`

Data type: `Optional[Enum['Started', 'Stopped']]`

Indicates the state of the application pool. The values that are allowed for this property are: Started, Stopped.

#### Parameters

The following parameters are available in the `dsc_xwebapppool` type.

* [`dsc_credential`](#dsc_credential)
* [`dsc_name`](#dsc_name)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_credential"></a>`dsc_credential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Indicates the custom account crededentials. This property is only valid when the identityType property is set to
SpecificUser.

##### <a name="dsc_name"></a>`dsc_name`

namevar

Data type: `String`

Indicates the application pool name. The value must contain between 1 and 64 characters.

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xwebapppooldefaults"></a>`dsc_xwebapppooldefaults`

The DSC xWebAppPoolDefaults resource type.
Automatically generated from version 3.2.0

#### Properties

The following properties are available in the `dsc_xwebapppooldefaults` type.

##### `dsc_identitytype`

Data type: `Optional[Enum['ApplicationPoolIdentity', 'LocalService', 'LocalSystem', 'NetworkService']]`

applicationPools/applicationPoolDefaults/processModel/identityType

##### `dsc_managedruntimeversion`

Data type: `Optional[Enum['', 'v2.0', 'v4.0']]`

applicationPools/applicationPoolDefaults/managedRuntimeVersion

#### Parameters

The following parameters are available in the `dsc_xwebapppooldefaults` type.

* [`dsc_issingleinstance`](#dsc_issingleinstance)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_issingleinstance"></a>`dsc_issingleinstance`

namevar

Data type: `Enum['Yes']`

Specifies the resource is a single instance, the value must be 'Yes'

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xwebconfigkeyvalue"></a>`dsc_xwebconfigkeyvalue`

The DSC xWebConfigKeyValue resource type.
Automatically generated from version 3.2.0

#### Properties

The following properties are available in the `dsc_xwebconfigkeyvalue` type.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Indicates if the property and value should be present or absent. Defaults to Present.

##### `dsc_isattribute`

Data type: `Optional[Boolean]`

If the given key value pair is for attribute, default is element

##### `dsc_value`

Data type: `Optional[String]`

Value for AppSettings

#### Parameters

The following parameters are available in the `dsc_xwebconfigkeyvalue` type.

* [`dsc_configsection`](#dsc_configsection)
* [`dsc_key`](#dsc_key)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`dsc_websitepath`](#dsc_websitepath)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_configsection"></a>`dsc_configsection`

namevar

Data type: `Enum['AppSettings']`

Config Section to be update

##### <a name="dsc_key"></a>`dsc_key`

namevar

Data type: `String`

Key for AppSettings

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="dsc_websitepath"></a>`dsc_websitepath`

namevar

Data type: `String`

Path to website location(IIS or WebAdministration format)

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xwebconfigproperty"></a>`dsc_xwebconfigproperty`

The DSC xWebConfigProperty resource type.
Automatically generated from version 3.2.0

#### Properties

The following properties are available in the `dsc_xwebconfigproperty` type.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Indicates if the property and value should be present or absent. Defaults to Present.

##### `dsc_value`

Data type: `Optional[String]`

Value of the property to update.

#### Parameters

The following parameters are available in the `dsc_xwebconfigproperty` type.

* [`dsc_filter`](#dsc_filter)
* [`dsc_propertyname`](#dsc_propertyname)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`dsc_websitepath`](#dsc_websitepath)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_filter"></a>`dsc_filter`

namevar

Data type: `String`

Filter used to locate property to update.

##### <a name="dsc_propertyname"></a>`dsc_propertyname`

namevar

Data type: `String`

Name of the property to update.

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="dsc_websitepath"></a>`dsc_websitepath`

namevar

Data type: `String`

Path to website location (IIS or WebAdministration format).

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xwebconfigpropertycollection"></a>`dsc_xwebconfigpropertycollection`

The DSC xWebConfigPropertyCollection resource type.
Automatically generated from version 3.2.0

#### Properties

The following properties are available in the `dsc_xwebconfigpropertycollection` type.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Indicates if the property and value of the property collection item should be present or absent. Defaults to Present.

##### `dsc_itempropertyvalue`

Data type: `Optional[String]`

Value of the property of the property collection item to update.

#### Parameters

The following parameters are available in the `dsc_xwebconfigpropertycollection` type.

* [`dsc_collectionname`](#dsc_collectionname)
* [`dsc_filter`](#dsc_filter)
* [`dsc_itemkeyname`](#dsc_itemkeyname)
* [`dsc_itemkeyvalue`](#dsc_itemkeyvalue)
* [`dsc_itemname`](#dsc_itemname)
* [`dsc_itempropertyname`](#dsc_itempropertyname)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`dsc_websitepath`](#dsc_websitepath)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_collectionname"></a>`dsc_collectionname`

namevar

Data type: `String`

Name of the property collection to update.

##### <a name="dsc_filter"></a>`dsc_filter`

namevar

Data type: `String`

Filter used to locate property collection to update.

##### <a name="dsc_itemkeyname"></a>`dsc_itemkeyname`

namevar

Data type: `String`

Name of the key of the property collection item to update.

##### <a name="dsc_itemkeyvalue"></a>`dsc_itemkeyvalue`

namevar

Data type: `String`

Value of the key of the property collection item to update.

##### <a name="dsc_itemname"></a>`dsc_itemname`

namevar

Data type: `String`

Name of the property collection item to update.

##### <a name="dsc_itempropertyname"></a>`dsc_itempropertyname`

namevar

Data type: `String`

Name of the property of the property collection item to update.

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="dsc_websitepath"></a>`dsc_websitepath`

namevar

Data type: `String`

Path to website location (IIS or WebAdministration format).

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xwebsite"></a>`dsc_xwebsite`

The DSC xWebSite resource type.
Automatically generated from version 3.2.0

#### Properties

The following properties are available in the `dsc_xwebsite` type.

##### `dsc_applicationpool`

Data type: `Optional[String]`

The name of the websiteâ??s application pool.

##### `dsc_applicationtype`

Data type: `Optional[String]`

Adds a AutostartProvider ApplicationType

##### `dsc_authenticationinfo`

Data type: `Optional[Struct[{
              basic => Optional[Boolean],
              anonymous => Optional[Boolean],
              digest => Optional[Boolean],
              windows => Optional[Boolean]
            }]]`

Hashtable containing authentication information (Anonymous, Basic, Digest, Windows)

##### `dsc_bindinginfo`

Data type: `Optional[Array[Struct[{
              sslflags => Optional[Enum['0', '1', '2', '3']],
              certificatestorename => Optional[Enum['My', 'WebHosting']],
              certificatethumbprint => Optional[String],
              hostname => Optional[String],
              certificatesubject => Optional[String],
              bindinginformation => Optional[String],
              port => Optional[Integer[0, 65535]],
              ipaddress => Optional[String],
              protocol => Enum['http', 'https', 'msmq.formatname', 'net.msmq', 'net.pipe', 'net.tcp']
            }]]]`

Website's binding information in the form of an array of embedded instances of the MSFT_xWebBindingInformation CIM class.

##### `dsc_defaultpage`

Data type: `Optional[Array[String]]`

One or more names of files that will be set as Default Documents for this website.

##### `dsc_enabledprotocols`

Data type: `Optional[String]`

The protocols that are enabled for the website.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Ensures that the website is Present or Absent. Defaults to Present.

##### `dsc_logcustomfields`

Data type: `Optional[Array[Struct[{
              sourcetype => Optional[Enum['RequestHeader', 'ResponseHeader', 'ServerVariable']],
              sourcename => Optional[String],
              logfieldname => Optional[String],
            }]]]`

Custom logging field information in the form of an array of embedded instances of MSFT_xLogCustomFieldInformation CIM class

##### `dsc_logflags`

Data type: `Optional[Array[Enum['Date', 'Time', 'ClientIP', 'UserName', 'SiteName', 'ComputerName', 'ServerIP', 'Method', 'UriStem', 'UriQuery', 'HttpStatus', 'Win32Status', 'BytesSent', 'BytesRecv', 'TimeTaken', 'ServerPort', 'UserAgent', 'Cookie', 'Referer', 'ProtocolVersion', 'Host', 'HttpSubStatus']]]`

The W3C logging fields

##### `dsc_logformat`

Data type: `Optional[Enum['IIS', 'W3C', 'NCSA']]`

Format of the Logfiles. Only W3C supports LogFlags

##### `dsc_loglocaltimerollover`

Data type: `Optional[Boolean]`

Use the localtime for file naming and rollover

##### `dsc_logpath`

Data type: `Optional[String]`

The directory to be used for logfiles

##### `dsc_logperiod`

Data type: `Optional[Enum['Hourly', 'Daily', 'Weekly', 'Monthly', 'MaxSize']]`

How often the log file should rollover

##### `dsc_logtargetw3c`

Data type: `Optional[Enum['File', 'ETW', 'File,ETW']]`

Specifies whether IIS will use Event Tracing or file logging

##### `dsc_logtruncatesize`

Data type: `Optional[String]`

How large the file should be before it is truncated

##### `dsc_physicalpath`

Data type: `Optional[String]`

The path to the files that compose the website.

##### `dsc_preloadenabled`

Data type: `Optional[Boolean]`

When set to $true this will allow WebSite to automatically start without a request

##### `dsc_serverautostart`

Data type: `Optional[Boolean]`

When set to $true this will enable Autostart on a Website

##### `dsc_serviceautostartenabled`

Data type: `Optional[Boolean]`

When set to `$true` this will enable application Autostart (application initalization without an initial request) on a Website

##### `dsc_serviceautostartprovider`

Data type: `Optional[String]`

Adds a AutostartProvider

##### `dsc_siteid`

Data type: `Optional[Integer[0, 4294967295]]`

Optional. The desired IIS site Id for the website.

##### `dsc_state`

Data type: `Optional[Enum['Started', 'Stopped']]`

The state of the website.

#### Parameters

The following parameters are available in the `dsc_xwebsite` type.

* [`dsc_name`](#dsc_name)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_name"></a>`dsc_name`

namevar

Data type: `String`

The desired name of the website.

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xwebsitedefaults"></a>`dsc_xwebsitedefaults`

The DSC xWebSiteDefaults resource type.
Automatically generated from version 3.2.0

#### Properties

The following properties are available in the `dsc_xwebsitedefaults` type.

##### `dsc_allowsubdirconfig`

Data type: `Optional[Enum['true', 'false']]`

sites/virtualDirectoryDefaults/allowSubDirConfig

##### `dsc_defaultapplicationpool`

Data type: `Optional[String]`

sites/applicationDefaults/applicationPool

##### `dsc_logdirectory`

Data type: `Optional[String]`

sites/siteDefaults/logFile/directory

##### `dsc_logformat`

Data type: `Optional[Enum['W3C', 'IIS', 'NCSA', 'Custom']]`

sites/siteDefaults/logFile/logFormat

##### `dsc_tracelogdirectory`

Data type: `Optional[String]`

sites/siteDefaults/traceFailedRequestsLogging/directory

#### Parameters

The following parameters are available in the `dsc_xwebsitedefaults` type.

* [`dsc_issingleinstance`](#dsc_issingleinstance)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_issingleinstance"></a>`dsc_issingleinstance`

namevar

Data type: `Enum['Yes']`

Specifies the resource is a single instance, the value must be 'Yes'

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xwebvirtualdirectory"></a>`dsc_xwebvirtualdirectory`

The DSC xWebVirtualDirectory resource type.
Automatically generated from version 3.2.0

#### Properties

The following properties are available in the `dsc_xwebvirtualdirectory` type.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Whether virtual directory should be present or absent

##### `dsc_physicalpath`

Data type: `String`

Physical path for the virtual directory

#### Parameters

The following parameters are available in the `dsc_xwebvirtualdirectory` type.

* [`dsc_name`](#dsc_name)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`dsc_webapplication`](#dsc_webapplication)
* [`dsc_website`](#dsc_website)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_name"></a>`dsc_name`

namevar

Data type: `String`

Name of virtual directory

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="dsc_webapplication"></a>`dsc_webapplication`

namevar

Data type: `String`

Web application name for the virtual directory

##### <a name="dsc_website"></a>`dsc_website`

namevar

Data type: `String`

Name of website with which Web Application is associated

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

