require 'puppet/resource_api'

Puppet::ResourceApi.register_type(
  name: 'dsc_xwebsitedefaults',
  dscmeta_resource_friendly_name: 'xWebSiteDefaults',
  dscmeta_resource_name: 'MSFT_xWebSiteDefaults',
  dscmeta_resource_implementation: 'MOF',
  dscmeta_module_name: 'xWebAdministration',
  dscmeta_module_version: '3.2.0',
  docs: 'The DSC xWebSiteDefaults resource type.
         Automatically generated from version 3.2.0',
  features: ['simple_get_filter', 'canonicalize', 'custom_insync'],
  attributes: {
    name: {
      type:      'String',
      desc:      'Description of the purpose for this resource declaration.',
      behaviour: :namevar,
    },
    validation_mode: {
      type:      'Enum[property, resource]',
      desc:      'Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode (resource).',
      behaviour: :parameter,
      default:   'property',
    },
    dsc_psdscrunascredential: {
      type: 'Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]',
      desc: ' ',
      behaviour: :parameter,
      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'PSCredential',
      mof_is_embedded: true,
    },
    dsc_logdirectory: {
      type: 'Optional[String]',
      desc: 'sites/siteDefaults/logFile/directory',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_defaultapplicationpool: {
      type: 'Optional[String]',
      desc: 'sites/applicationDefaults/applicationPool',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_allowsubdirconfig: {
      type: "Optional[Enum['true', 'false']]",
      desc: 'sites/virtualDirectoryDefaults/allowSubDirConfig',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_logformat: {
      type: "Optional[Enum['W3C', 'IIS', 'NCSA', 'Custom']]",
      desc: 'sites/siteDefaults/logFile/logFormat',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_issingleinstance: {
      type: "Enum['Yes']",
      desc: "Specifies the resource is a single instance, the value must be 'Yes'",
      behaviour: :namevar,
      mandatory_for_get: true,
      mandatory_for_set: true,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_tracelogdirectory: {
      type: 'Optional[String]',
      desc: 'sites/siteDefaults/traceFailedRequestsLogging/directory',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'String',
      mof_is_embedded: false,
    },
  },
)
