# culture="en-US"
ConvertFrom-StringData -StringData @'
    ErrorWebsiteNotFound = The requested website "{0}" cannot be found on the target machine.
    ErrorWebsiteDiscoveryFailure = Failure to get the requested website "{0}" information from the target machine.
    ErrorWebsiteCreationFailure = Failure to successfully create the website "{0}". Error: "{1}".
    ErrorWebsiteRemovalFailure = Failure to successfully remove the website "{0}". Error: "{1}".
    ErrorWebsiteBindingUpdateFailure = Failure to successfully update the bindings for website "{0}". Error: "{1}".
    ErrorWebsiteBindingInputInvalidation = Desired website bindings are not valid for website "{0}".
    ErrorWebsiteCompareFailure = Failure to successfully compare properties for website "{0}". Error: "{1}".
    ErrorWebBindingCertificate = Failure to add certificate to web binding. Please make sure that the certificate thumbprint "{0}" is valid. Error: "{1}".
    ErrorWebsiteStateFailure = Failure to successfully set the state of the website "{0}". Error: "{1}".
    ErrorWebsiteBindingConflictOnStart = Website "{0}" could not be started due to binding conflict. Ensure that the binding information for this website does not conflict with any existing website's bindings before trying to start it.
    ErrorWebBindingInvalidIPAddress = Failure to validate the IPAddress property value "{0}". Error: "{1}".
    ErrorWebBindingInvalidPort = Failure to validate the Port property value "{0}". The port number must be a positive integer between 1 and 65535.
    ErrorWebBindingMissingBindingInformation = The BindingInformation property is required for bindings of type "{0}".
    ErrorWebBindingMissingCertificateThumbprint = The CertificateThumbprint property is required for bindings of type "{0}".
    ErrorWebBindingMissingSniHostName = The HostName property is required for use with Server Name Indication.
    ErrorWebBindingInvalidCertificateSubject = The Subject "{0}" provided is not found on this host in store "{1}"
    ErrorWebsiteTestAutoStartProviderFailure = Desired AutoStartProvider is not valid due to a conflicting Global Property. Ensure that the serviceAutoStartProvider is a unique key."
    VerboseSetTargetUpdatedSiteId = Site Id for website "{0}" has been updated to "{1}".
    VerboseSetTargetUpdatedPhysicalPath = Physical Path for website "{0}" has been updated to "{1}".
    VerboseGetTargetAbsent = No Website exists with this name.
    VerboseGetTargetPresent = A single Website exists with this name
    VerboseSetTargetUpdatedApplicationPool = Application Pool for website "{0}" has been updated to "{1}".
    VerboseSetTargetUpdatedBindingInfo = Bindings for website "{0}" have been updated.
    VerboseSetTargetUpdatedEnabledProtocols = Enabled Protocols for website "{0}" have been updated to "{1}".
    VerboseSetTargetUpdatedState = State for website "{0}" has been updated to "{1}".
    VerboseSetTargetWebsiteCreated = Successfully created website "{0}".
    VerboseSetTargetWebsiteStarted = Successfully started website "{0}".
    VerboseSetTargetWebsiteRemoved = Successfully removed website "{0}".
    VerboseSetTargetWebsiteAutoStartUpdated = Successfully updated AutoStart on website "{0}".
    VerboseSetTargetAuthenticationInfoUpdated = Successfully updated AuthenticationInfo on website "{0}".
    VerboseSetTargetWebsitePreloadUpdated = Successfully updated application Preload on website "{0}".
    VerboseSetTargetServiceAutoStartProviderUpdated = Successfully updated AutoStartProvider on website "{0}".
    VerboseSetTargetIISAutoStartProviderUpdated = Successfully updated AutoStartProvider in IIS.
    VerboseSetTargetUpdateLogPath = LogPath does not match and will be updated on Website "{0}".
    VerboseSetTargetUpdateLogFlags = LogFlags do not match and will be updated on Website "{0}".
    VerboseSetTargetUpdateLogPeriod = LogPeriod does not match and will be updated on Website "{0}".
    VerboseSetTargetUpdateLogTruncateSize = TruncateSize does not match and will be updated on Website "{0}".
    VerboseSetTargetUpdateLoglocalTimeRollover = LoglocalTimeRollover does not match and will be updated on Website "{0}".
    VerboseSetTargetUpdateLogFormat = LogFormat is not in the desired state and will be updated on Website "{0}"
    VerboseSetTargetUpdateLogTargetW3C = LogTargetW3C is not in the desired state and will be updated on Website "{0}".
    VerboseSetTargetUpdateLogCustomFields = LogCustomFields is not in the desired state and will be updated on Website "{0}"
    VerboseTestTargetFalseEnsure = The Ensure state for website "{0}" does not match the desired state.
    VerboseTestTargetFalseSiteId = Site Id of website "{0}" does not match the desired state.
    VerboseTestTargetFalsePhysicalPath = Physical Path of website "{0}" does not match the desired state.
    VerboseTestTargetFalseState = The state of website "{0}" does not match the desired state.
    VerboseTestTargetFalseApplicationPool = Application Pool for website "{0}" does not match the desired state.
    VerboseTestTargetFalseBindingInfo = Bindings for website "{0}" do not match the desired state.
    VerboseTestTargetFalseEnabledProtocols = Enabled Protocols for website "{0}" do not match the desired state.
    VerboseTestTargetFalseDefaultPage = Default Page for website "{0}" does not match the desired state.
    VerboseTestTargetTrueResult = The target resource is already in the desired state. No action is required.
    VerboseTestTargetFalseResult = The target resource is not in the desired state.
    VerboseTestTargetFalseAutoStart = AutoStart for website "{0}" do not match the desired state.
    VerboseTestTargetFalsePreload = Preload for website "{0}" do not match the desired state.
    VerboseTestTargetFalseServiceAutoStart = Application AutoStart for website "{0}" do not match the desired state.
    VerboseTestTargetFalseAuthenticationInfo = AuthenticationInfo for website "{0}" is not in the desired state.
    VerboseTestTargetFalseIISAutoStartProvider = AutoStartProvider for IIS is not in the desired state
    VerboseTestTargetFalseLogPath = LogPath does not match desired state on Website "{0}".
    VerboseTestTargetFalseLogFlags = LogFlags does not match desired state on Website "{0}".
    VerboseTestTargetFalseLogPeriod = LogPeriod does not match desired state on Website "{0}".
    VerboseTestTargetFalseLogTruncateSize = LogTruncateSize does not match desired state on Website "{0}".
    VerboseTestTargetFalseLoglocalTimeRollover = LoglocalTimeRollover does not match desired state on Website "{0}".
    VerboseTestTargetFalseLogFormat = LogFormat does not match desired state on Website "{0}".
    VerboseTestTargetFalseLogTargetW3C = LogTargetW3C does not match desired state on Website "{0}".
    VerboseConvertToWebBindingIgnoreBindingInformation = BindingInformation is ignored for bindings of type "{0}" in case at least one of the following properties is specified: IPAddress, Port, HostName.
    VerboseConvertToWebBindingDefaultPort = Port is not specified. The default "{0}" port "{1}" will be used.
    VerboseConvertToWebBindingDefaultCertificateStoreName = CertificateStoreName is not specified. The default value "{0}" will be used.
    VerboseTestBindingInfoSameIPAddressPortHostName = BindingInfo contains multiple items with the same IPAddress, Port, and HostName combination.
    VerboseTestBindingInfoSamePortDifferentProtocol = BindingInfo contains items that share the same Port but have different Protocols.
    VerboseTestBindingInfoSameProtocolBindingInformation = BindingInfo contains multiple items with the same Protocol and BindingInformation combination.
    VerboseTestBindingInfoInvalidCatch = Unable to validate BindingInfo: "{0}".
    VerboseUpdateDefaultPageUpdated = Default page for website "{0}" has been updated to "{1}".
    WarningLogPeriod = LogTruncateSize has is an input as will overwrite this desired state on Website "{0}".
    WarningIncorrectLogFormat = LogFormat is not W3C, as a result LogFlags will not be used on Website "{0}".
    VerboseTestTargetUpdateLogCustomFields = LogCustomFields does not match desired state on Website "{0}".
'@
